<html devsite>
<head>
  <title>Including DTBO in Recovery for Non-A/B Devices</title>
  <meta name="project_path" value="/_project.yaml">
  <meta name="book_path" value="/_book.yaml">
</head>

<body>
  {% include "_versions.html" %} <!--
      Copyright 2018 The Android Open Source Project

      Licensed under the Apache License, Version 2.0 (the "License");
      you may not use this file except in compliance with the License.
      You may obtain a copy of the License at

          http://www.apache.org/licenses/LICENSE-2.0

      Unless required by applicable law or agreed to in writing, software
      distributed under the License is distributed on an "AS IS" BASIS,
      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
      See the License for the specific language governing permissions and
      limitations under the License.
  -->
   To prevent OTA failures on non-A/B devices, the recovery partition must be
  self-sufficient and cannot depend on other partitions.

  <p>While booting into recovery, the bootloader must load the DTBO image that
  is compatible with the recovery image. During an OTA, if a problem occurs
  after the DTBO image has been updated (but prior to completing the full
  update), the device will try to boot into recovery mode to complete the OTA.
  However, because the DTBO partition has already been updated, a mismatch
  could occur with the recovery image (which has not yet been updated).</p>


  <p>To prevent this situation, in Android {{ androidPVersionNumber }} the recovery
  image must also contain information from the DTBO image. The recovery image for a
  non-A/B device must also contain the device's DTB appended to kernel so as to not
  depend on the DTB partition during an update.</p>


  <h2 id="boot-image-changes">Boot image changes</h2>


  <p>To allow the recovery image to contain the recovery DTBO, the format of
  boot image in Android {{ androidPVersionNumber }} is:</p>


  <table>
    <tr>
      <td>Boot header (1 page)</td>
    </tr>


    <tr>
      <td>Kernel (<em>l</em> pages)</td>
    </tr>


    <tr>
      <td>Ramdisk (<em>m</em> pages)</td>
    </tr>


    <tr>
      <td>Second stage (<em>n</em> pages)</td>
    </tr>


    <tr>
      <td>Recovery DTBO (<em>o</em> pages)</td>
    </tr>
  </table>


  <p>In addition, the <code>mkbootimg</code> tool that creates boot images
  includes the following new arguments:</p>


  <table>
    <tr>
      <th><strong>Argument</strong>
      </th>

      <th><strong>Description</strong>
      </th>
    </tr>


    <tr>
      <td><code>header_version</code>
      </td>

      <td>Sets the boot image header version. A boot image with a header
      version greater than or equal to 1 supports the recovery DTBO
      section.</td>
    </tr>


    <tr>
      <td><code>recovery_dtbo</code>
      </td>

      <td>Path to the recovery DTBO image.</td>
    </tr>
  </table>


  <p>For details on modifications to the legacy boot image header, refer to
  <em><a href="/devices/bootloader/boot-image-header">Boot Image Header
  Versioning in Android {{ androidPVersionNumber }}</a></em>.</p>


  <h2 id="implementation">Implementation</h2>


  <p>Although all devices launching with Android {{ androidPVersionNumber }}
  must use the new boot image header (version 1), only non-A/B devices are
  required to populate the <code>recovery_dtbo</code> section of the recovery
  image. To include the <code>recovery_dtbo</code> image in <code>recovery.img</code>,
  in the device <code>BoardConfig.mk</code>:</p>


  <ul>
    <li>Set the config <code>BOARD_INCLUDE_RECOVERY_DTBO</code> to
    <code>true</code>:

      <pre class="prettyprint">BOARD_INCLUDE_RECOVERY_DTBO := true</pre>
    </li>
  </ul>


  <ul>
    <li>Extend the <code>BOARD_MKBOOTIMG_ARGS</code> variable to specify the
    boot image header version:

      <pre class="prettyprint">
      BOARD_MKBOOTIMG_ARGS := --ramdisk_offset $(BOARD_RAMDISK_OFFSET) --tags_offset $(BOARD_KERNEL_TAGS_OFFSET) --header_version $(BOARD_BOOTIMG_HEADER_VERSION)</pre>
    </li>
  </ul>


  <ul>
    <li>Ensure the <code>BOARD_PREBUILT_DTBOIMAGE</code> variable is set to the
    path of the DTBO image. The Android build system uses the variable to set
    the argument <code>recovery_dtbo</code> of mkbootimg tool during the
    creation of recovery image.</li>
  </ul>


  <ul>
    <li>If the variables <code>BOARD_INCLUDE_RECOVERY_DTBO</code>,
    <code>BOARD_MKBOOTIMG_ARGS</code>, and
    <code>BOARD_PREBUILT_DTBOIMAGE</code> are set correctly, the Android build
    system uses the DTBO specified by the variable
    <code>BOARD_PREBUILT_DTBOIMAGE</code> to include in
    <code>recovery.img</code>.</li>
  </ul>


  <h2 id="validation">Validation</h2>


  <p>For all devices launching with Android {{ androidPVersionNumber }}, the <a href=
  "/compatibility/vts/">Vendor Test Suite (VTS)</a> checks the format of the
  boot/recovery image to ensure the boot image header uses version 1.</p>
</body>
</html>
